SystemOrganization addCategory: #'OpalCompiler-SystemFixes'!

!RBMethodNode methodsFor: '*OpalCompiler-SystemFixes' stamp: 'EstebanAllende 3/6/2013 14:49'!
sourceText: aString 
	source := aString.! !

!RBMethodNode methodsFor: '*OpalCompiler-SystemFixes' stamp: 'EstebanAllende 3/7/2013 14:19'!
tempNames
	^self ir tempNames! !

!TimeProfiler methodsFor: '*OpalCompiler-SystemFixes' stamp: 'EstebanAllende 3/5/2013 15:36'!
fullReportMenu: aMenuMorph shift: aBoolean
	^ (PragmaMenuBuilder 
		pragmaKeyword: 'TimeProfilerFullReportMenu'
		model: self) menu ! !

!OCParser methodsFor: '*OpalCompiler-SystemFixes' stamp: 'EstebanAllende 3/7/2013 16:47'!
parse: sourceStream class: parseScope noPattern: doitBool notifying: req ifFail: aBlock
	"Parse sourceStream into a embedded BlockNode if doitFlag is true (no method header) or a MethodNode if doitFlag is false.  Parsing is done with respect to parseScope to find non-local variables.  Errors in parsing are reported to req if not nil followed by executing the fail block."

	| parser tree |

	source := sourceStream.
	requestor := req.
	doitFlag := doitBool.
	scope := parseScope parseScope.
	failBlock := [^ aBlock value].

	parser := self realParserClass.

	tree := doitFlag 
			ifTrue: [parser parseDoIt: source contents]
			ifFalse: [parser parseMethod: source contents].
	parseScope isBehavior ifTrue: [tree methodClass: parseScope].
	^tree doSemanticAnalysisIn: scope! !
